package rknop;

import rknop.*;
import java.lang.*;
import java.io.*;
import java.util.*;

public class FileVecReader {
  FileReader fr;
  BufferedReader br;
  String filename;

  public FileVecReader(String infilename) 
    throws FileNotFoundException
  {
    filename=infilename;
    fr=new FileReader(filename);
    br=new BufferedReader(fr);
  }

  public void finalize() throws IOException {
    br.close();
  }

  public Vector readVec() throws FileNotFoundException,IOException {
    Vector v=new Vector();
    String line;

    while ((line=br.readLine())!=null) {
      v.addElement(line);
    }

    br.close();

    // Re-open the file so that we can reread if we wish
    //  (It would be better to do this with mark() and reset(), but
    //   that requires me to specify a buffer size... intelligent
    //   could would check the exception return of reset(), and in
    //   the case of an exception close and reopen the file.)

    fr=new FileReader(filename);
    br=new BufferedReader(fr);

    return v;
  }
}
