package rknop;

import rknop.*;
import java.lang.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class Steege {
    
    // **********************************************************************
    // getTopParent() -- returns the top level Frame of which the
    //   passed component is a descendent

    public static Frame getTopParent(Component component) {
        Component c=component;
        while (c.getParent()!=null)
            c=c.getParent();
        if (c instanceof Frame)
            return (Frame)c;
        else
            return null;
    }

    // **********************************************************************
    // centerDialog()

    public static void centerDialog(Dialog dlg,Component parent) {
        Point pnt=parent.getLocation();
        Dimension d=parent.getSize();
        Dimension s=dlg.getSize();
        pnt.translate((d.width-s.width)/2,(d.height-s.height)/2);
        dlg.setLocation(pnt);
    }

    // **********************************************************************
    // cleanupContainer() -- Recursively tries to clean out all elements
    //   from all containers and subcontainers

    // public static void cleanupContainer(Container top) {
    //     Component[] comps=top.getComponents();
    //     Component c;
    //     EventListener[] listeners;
    //
    //     top.setVisible(false);
    // 
    //     for (int i=0 ; i<comps.length ; ++i) {
    //         c=comps[i];
    //         if (c instanceof Container) {
    //             Steege.cleanupContainer((Container)c);
    //         }
    //         c.setVisible(false);
    //         c.setEnabled(false);
    //         top.remove(c);
    //
    //         listeners=c.getListeners(MouseListener.class);
    //         for (int j=0 ; j<listeners.length ; ++j) {
    //             c.removeMouseListener((MouseListener)listeners[j]);
    //         }
    //         listeners=c.getListeners(MouseMotionListener.class);
    //         for (int j=0 ; j<listeners.length ; ++j) {
    //             c.removeMouseMotionListener((MouseMotionListener)listeners[j]);
    //         }
    //         listeners=c.getListeners(ActionListener.class);
    //         for (int j=0 ; j<listeners.length ; ++j) {
    //             c.removeActionListener((ActionListener)listeners[j]);
    //         }
    //         listeners=c.getListeners(WindowListener.class);
    //         for (int j=0 ; j<listeners.length ; ++j) {
    //             c.removeWindowListener((WindowListener)listeners[j]);
    //         }
    //     }
    // }

    // **********************************************************************
    // splitLines() -- split a string at line termiantors, return
    //                  the indivudal lines in an array

    public static String[] splitLines(String alltext) {
        String lines[],line,term;
        Vector vlines;
        int pos,next;

        term=System.getProperty("line.separator");
        vlines=new Vector();
        pos=0;
        next=alltext.indexOf(term);
        while (next>=0) {
            line=alltext.substring(pos,next);
            vlines.addElement(line);
            pos=next+term.length();
            next=alltext.indexOf(term,pos);
        }
        if (pos<alltext.length()) {
            line=alltext.substring(pos);
            vlines.addElement(line);
        }

        lines=new String[vlines.size()];        // necessary??
        vlines.copyInto(lines);

        return lines;
    }


    // **********************************************************************
    // splitSpaces() -- split a string at spaces, return the individual
    //   components in an array.

    public static String[] splitSpaces(String line) {
        return splitSpaces(line,-1);
    }

    public static String[] splitSpaces(String line,int maxfields) {
        int num=0;
        String strings[];
        int off,next,i;

        // First, count the number we'll need.
        num=0;
        off=0;
        while ((next=line.indexOf(" ",off)) >=0) {
            if (next==off) ++off;
            else {
                if (off>=line.length()) break;
                else {
                    ++num;
                    off=next+1;
                }
            }
        }
        if (off<line.length()) ++num;
        if (maxfields>0 && num>maxfields) num=maxfields;
        strings=new String[num];

        // Pull out the substrings
        i=0;
        off=0;
        while (i<num-1) {
            next=line.indexOf(" ",off);
            if (next==off) ++off;
            else {
                strings[i++]=new String(line.substring(off,next));
                off=next+1;
            }
        }
        if (num>0) {
            while (line.substring(off,off+1).equals(" ")) ++off;
            strings[num-1]=new String(line.substring(off));
        }

        return strings;
    }

}
