package rknop.jvmap;

import rknop.*;
import rknop.jvmap.*;
import java.lang.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;
import java.net.*;

// **********************************************************************
// **********************************************************************
// A die roller....
// **********************************************************************
// **********************************************************************

class DiceMail extends Frame implements ActionListener {
    static final boolean debug=false;
    
    public static String smtpserver;
    public static String smtpport;
    public static String email;

    Button rollbutton,closebutton;

    private TextField smtpservertf,smtpporttf,emailtf,subjecttf;
    private TextField numdicetf,numsidestf,modifiertf,numrollstf;
    private TextArea whatfor,recipients;
    private Checkbox doemail;

    // **********************************************************************
    // Class constructor

    static {
        smtpserver=System.getProperty("rknop.jvmap.smtpserver");
        if (smtpserver==null) smtpserver=new String("");
        smtpport=System.getProperty("rknop.jvmap.smtpport");
        if (smtpport==null) smtpport=new String("25");
        email=System.getProperty("rknop.jvmap.email");
        if (email==null) email=new String("");
    }

    // **********************************************************************
    // Constructor

    public DiceMail(Vector players) {
        super("JV_Map Dice");

        Panel p1,p2,p3;
        Label l;
        BorderLayout blo;
        GridLayout glo;

        // Dice information

        p1=new Panel();
        blo=new BorderLayout();
        p1.setLayout(blo);
        add("North",p1);

        p2=new Panel();

        l=new Label("Dice/Roll:");
        p2.add(l);
        numdicetf=new TextField("1",4);
        p2.add(numdicetf);

        l=new Label("Sides/Die:");
        p2.add(l);
        numsidestf=new TextField("6",4);
        p2.add(numsidestf);

        l=new Label("Modifier:");
        p2.add(l);
        modifiertf=new TextField("0",4);
        p2.add(modifiertf);

        l=new Label("Total # Rolls:");
        p2.add(l);
        numrollstf=new TextField("1",4);
        p2.add(numrollstf);

        p1.add("North",p2);

        l=new Label("Indicate what these are for, one line per roll:");
        p1.add("Center",l);

        whatfor=new TextArea(10,60);
        p1.add("South",whatfor);


        // Mail information

        p3=new Panel();
        blo=new BorderLayout();
        p3.setLayout(blo);
        add("Center",p3);

        p1=new Panel();
        p3.add("North",p1);
        doemail=new Checkbox("E-mail roll results?",false);
        p1.add("North",doemail);

        p1=new Panel();
        glo=new GridLayout(4,1);
        p1.setLayout(glo);
        p3.add("Center",p1);
        
        p2=new Panel();
        blo=new BorderLayout();
        p2.setLayout(blo);
        l=new Label("SMTP Server:");
        p2.add("West",l);
        smtpservertf=new TextField(smtpserver);
        p2.add("Center",smtpservertf);
        p1.add(p2);

        p2=new Panel();
        blo=new BorderLayout();
        p2.setLayout(blo);
        l=new Label("SMTP Port:");
        p2.add("West",l);
        smtpporttf=new TextField(smtpport);
        p2.add("Center",smtpporttf);
        p1.add(p2);
        
        p2=new Panel();
        blo=new BorderLayout();
        p2.setLayout(blo);
        l=new Label("Your E-mail:");
        p2.add("West",l);
        emailtf=new TextField(email);
        p2.add("Center",emailtf);
        p1.add(p2);

        p2=new Panel();
        blo=new BorderLayout();
        p2.setLayout(blo);
        l=new Label("Subject:");
        p2.add("West",l);
        subjecttf=new TextField("JV_Map Dice");
        p2.add("Center",subjecttf);
        p1.add(p2);

        p2=new Panel();
        blo=new BorderLayout();
        p2.setLayout(blo);
        l=new Label("Recepients (one per line):");
        p2.add("North",l);
        recipients=new TextArea(5,40);
        recipients.setText("");
        for (int i=0 ; i<players.size() ; ++i) {
            PlayerInfo pl=(PlayerInfo)players.elementAt(i);
            recipients.append(pl.email);
            recipients.append(System.getProperty("line.separator"));
        }
        p2.add("Center",recipients);
        p3.add("South",p2);

        // Buttons at bottom

        p1=new Panel();
        blo=new BorderLayout();
        p1.setLayout(blo);
        add("South",p1);

        rollbutton=new Button("Roll 'Em");
        rollbutton.setActionCommand("Roll");
        rollbutton.addActionListener(this);
        p1.add("West",rollbutton);

        closebutton=new Button("Close");
        closebutton.setActionCommand("Close");
        closebutton.addActionListener(this);
        p1.add("East",closebutton);


        // Show the window

        pack();
        setVisible(true);
    }

    // **********************************************************************
    // "destructor"

    public void cleanup() {
        setVisible(false);
        rollbutton.removeActionListener(this);
        closebutton.removeActionListener(this);
        dispose();
    }

    // **********************************************************************
    // ActionListener method

    public void actionPerformed(ActionEvent e) {
        String com=e.getActionCommand();

        if (com.equals("Roll")) {
            rollDice();
        }
        else if (com.equals("Close")) {
            cleanup();
        }
    }

    // **********************************************************************
    // rollDice()

    public void rollDice() {
        Random random=new Random();
        int numrolls,numdice,sides,modifier;
        int results[],i,j,val,maxpad;
        String resulttext[],lines[],spacepad;
        String line,alltext,dicestring,term;

        numrolls=Integer.parseInt(numrollstf.getText());
        numdice=Integer.parseInt(numdicetf.getText());
        sides=Integer.parseInt(numsidestf.getText());
        modifier=Integer.parseInt(modifiertf.getText());

        results=new int[numrolls];
        for (i=0 ; i<numrolls ; ++i) {
            results[i]=modifier;
            for (j=0 ; j<numdice ; ++j) {
                val=0;
                while (val<1 || val>sides) {
                    val=(int)Math.floor(random.nextFloat()*sides)+1;
                }
                results[i]+=val;
            }
        }

        // Pull out strings from the textarea

        lines=Steege.splitLines(whatfor.getText());

        // Build the resulttext array

        if (numrolls>lines.length) {
            resulttext=new String[numrolls];
        } else {
            resulttext=new String[lines.length];
        }

        dicestring=String.valueOf(numdice)+"d"+String.valueOf(sides);
        if (modifier<0) {
            dicestring+=String.valueOf(modifier);
        } else if (modifier>0) {
            dicestring+="+"+String.valueOf(modifier);
        }
        dicestring+="= ";
        line=String.valueOf(numdice*sides+modifier);
        maxpad=dicestring.length()+line.length()+2;
        spacepad=" ";
        while (spacepad.length()<maxpad) spacepad+=spacepad;
        spacepad=spacepad.substring(0,maxpad);

        for (i=0 ; i<resulttext.length ; ++i) {
            line="";
            if (i<numrolls) {
                line=dicestring+String.valueOf(results[i]);
                for (j=line.length() ; j<maxpad ; ++j) {
                    line+=" ";
                }
                line+=": ";
            } else {
                line=spacepad+": ";
            }
            if (i<lines.length) {
                line+=lines[i];
            }
            resulttext[i]=new String(line);
        }

        // Do something with the results

        DiceResults dr=new DiceResults(resulttext);

        if (doemail.getState()) {
            mailResults(resulttext);
        }
    }

    // **********************************************************************
    // mailResults()

    public void mailResults(String resulttext[]) {
        InetAddress me,smtp;
        String hostname;
        Socket sock;
        OutputStream os;
        InputStream is;
        InputStreamReader isr;
        PrintWriter pw;
        BufferedReader br;
        int i;
        boolean firstrcpt;
        String line;
        MailStatus status=null;
        String rcpts[];

        try {
            me=InetAddress.getLocalHost();
            hostname=me.getHostName();
            smtp=InetAddress.getByName(smtpservertf.getText());
        }
        catch (UnknownHostException ex) {
            String text[]={ "Error sending mail, unknown host:",""};
            String buts[]={ "Fail" };
            text[1]=ex.getMessage();
            AreYouSure ays=new AreYouSure(this,"Mail Error",text,buts);
            return;
        }

        try {
            status=new MailStatus();
            sock=new Socket(smtp,Integer.parseInt(smtpporttf.getText()));
            os=sock.getOutputStream();
            pw=new PrintWriter(os,true);
            is=sock.getInputStream();
            isr=new InputStreamReader(is);
            br=new BufferedReader(isr);

            // Parse recpieients
            
            rcpts=Steege.splitLines(recipients.getText());

            // Start sending mail

            line=br.readLine();
            if (!line.substring(0,3).equals("220")) {
                throw new Exception(line);
            }
            if (debug) System.err.println(line);

            pw.println("HELO "+hostname);
            line=br.readLine();
            if (!line.substring(0,3).equals("250")) {
                throw new Exception(line);
            }
            if (debug) System.err.println(line);
            pw.println("MAIL From: "+emailtf.getText());
            line=br.readLine();
            if (!line.substring(0,3).equals("250")) {
                throw new Exception(line);
            }
            if (debug) System.err.println(line);
            for (i=0 ; i<rcpts.length; ++i) {
                if (rcpts[i].length()>0) {
                    pw.println("RCPT To: "+rcpts[i]);
                    line=br.readLine();
                    if (!line.substring(0,3).equals("250")) {
                        throw new Exception(line);
                    }
                    if (debug) System.err.println(line);
                }
            }
            pw.println("DATA");
            line=br.readLine();
            if (!line.substring(0,3).equals("354")) {
                throw new Exception(line);
            }
            if (debug) System.err.println(line);

            line="To: ";
            firstrcpt=true;
            for (i=0 ; i<rcpts.length; ++i) {
                if (rcpts[i].length()>0) {
                    if (firstrcpt) {
                        firstrcpt=false;
                    } else {
                        line=line+",";
                    }
                    line=line+rcpts[i];
                }
            }
            pw.println(line);

            pw.println("Subject: "+subjecttf.getText());
            pw.println("");
            pw.println("Die roll results from JV_Map:");
            pw.println("-----------------------------");
            for (i=0 ; i<resulttext.length ; ++i) {
                pw.println(resulttext[i]);
            }
            pw.println(".");
            line=br.readLine();
            if (!line.substring(0,3).equals("250")) {
                throw new Exception(line);
            }
            if (debug) System.err.println(line);
            pw.close();
            os.close();
            br.close();
            isr.close();
            is.close();
            sock.close();
        }
        catch (Exception ex) {
            status.cleanup();
            String text[]={ "Error while sending mail: ","" };
            String buts[]={ "Fail" };
            text[1]=ex.getMessage();
            AreYouSure ays=new AreYouSure(this,"Mail Error",text,buts);
            return;
        }
        
        status.done();
    }

    // **********************************************************************
    // **********************************************************************
    // class MailStatus

    class MailStatus extends Dialog implements ActionListener {

        Label msg;
        Button okbutton;

        public MailStatus() {
            super(DiceMail.this,"Mail Status",false);

            msg=new Label("Sending mail....");
            add("Center",msg);

            okbutton=new Button("OK");
            okbutton.addActionListener(this);
            okbutton.setEnabled(false);
            add("South",okbutton);

            pack();
            Steege.centerDialog(this,DiceMail.this);
            setVisible(true);
        }

        public void actionPerformed(ActionEvent e) {
            cleanup();
        }

        public void cleanup() {
            setVisible(false);
            okbutton.removeActionListener(this);
            dispose();
        }

        public void done() {
            msg.setText("Mail sent!");
            okbutton.setEnabled(true);
        }
    }

    // **********************************************************************
    // **********************************************************************
    // class DiceResults

    class DiceResults extends Dialog implements ActionListener {
        
        Button donebutton;
        
        public DiceResults(String resulttext[]) {
            super(DiceMail.this,"Dice Results",false);

            GridLayout glo;
            Panel p;
            Label l;
            int i;

            Font big=new Font("SansSerif",Font.BOLD,14);

            l=new Label("JV_Map Dice Results");
            l.setFont(big);
            add("North",l);

            p=new Panel();
            glo=new GridLayout(resulttext.length,1);
            p.setLayout(glo);
            for (i=0 ; i<resulttext.length ; ++i) {
                l=new Label(resulttext[i]);
                p.add(l);
            }
            add("Center",p);

            donebutton=new Button("Close");
            donebutton.addActionListener(this);
            add("South",donebutton);

            pack();

            // Center

            Point pnt=DiceMail.this.getLocation();
            Dimension d=DiceMail.this.getSize();
            Dimension s=getSize();
            pnt.translate((d.width-s.width)/2,(d.height-s.height)/2);
            setLocation(pnt);
            
            setVisible(true);
        }

        public void actionPerformed(ActionEvent e) {
            cleanup();
        }

        public void cleanup() {
            setVisible(false);
            smtpserver=smtpservertf.getText();
            smtpport=smtpporttf.getText();
            email=emailtf.getText();
            donebutton.removeActionListener(this);
            dispose();
        }
    }
}
